package com.liang.controller;

import com.liang.common.annotation.LogAround;
import com.liang.common.base.BaseController;
import com.liang.entity.BaseSchool;
import com.liang.service.BaseSchoolService;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * (BaseSchool)表控制层
 *
 * @author makejava
 * @since 2023-02-15 23:13:14
 */
@Controller
@RequestMapping("baseSchool")
public class BaseSchoolController extends BaseController {
    final static Logger logger = LoggerFactory.getLogger(com.liang.controller.BaseNationController.class);
    /**
     * 服务对象
     */
    @Resource
    private BaseSchoolService baseSchoolService;

    /**
     * 分页查询
     *
     * @param baseSchool  筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    @GetMapping
    public ResponseEntity<Page<BaseSchool>> queryByPage(BaseSchool baseSchool, PageRequest pageRequest) {
        return ResponseEntity.ok(this.baseSchoolService.queryByPage(baseSchool, pageRequest));
    }

    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @GetMapping("{id}")
    public ResponseEntity<BaseSchool> queryById(@PathVariable("id") Integer id) {
        return ResponseEntity.ok(this.baseSchoolService.queryById(id));
    }

    /**
     * 新增数据
     *
     * @param baseSchool 实体
     * @return 新增结果
     */
    @PostMapping
    public ResponseEntity<BaseSchool> add(BaseSchool baseSchool) {
        return ResponseEntity.ok(this.baseSchoolService.insert(baseSchool));
    }

    /**
     * 编辑数据
     *
     * @param baseSchool 实体
     * @return 编辑结果
     */
    @PutMapping
    public ResponseEntity<BaseSchool> edit(BaseSchool baseSchool) {
        return ResponseEntity.ok(this.baseSchoolService.update(baseSchool));
    }

    /**
     * 删除数据
     *
     * @param id 主键
     * @return 删除是否成功
     */
    @DeleteMapping
    public ResponseEntity<Boolean> deleteById(Integer id) {
        return ResponseEntity.ok(this.baseSchoolService.deleteById(id));
    }

    @ApiOperation(value = "页面初始化", notes = "页面初始化")
    @RequestMapping(value = "/init", method = RequestMethod.GET)
    public String init() {
        return "baseschool/list";
    }

    @LogAround("数据分页查询")
    @ApiOperation(value = "数据分页查询", notes = "数据分页查询")
    @ResponseBody
    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public Object list() {

        List<BaseSchool> list = baseSchoolService.queryAll();

        Map<String, Object> resultMap = new HashMap<>();
        resultMap.put("code", 0);
        resultMap.put("msg", "");
        resultMap.put("count", list.size());
        resultMap.put("data", list);

        return resultMap;
    }
}

